#include <bits/stdc++.h>
using namespace std;

#define pb push_back

long long n, k, x;
bool used[1000005];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

    cin >> n >> k >> x;

    if(k < n){
        for(long long i = 0; i < k; ++i){cout << 1 << " ";}
        cout << x + 1 << " ";
        for(long long i = k + 1; i < n; ++i){cout << x << " ";}
        cout << "\n";
    }
    else if(k == 3){
        if(n < 3){
            cout << -1 << "\n";
        }
        else if(n == 3){
            cout << 1 << " " << x + 1 << " " << 2 * x + 1 << "\n";
        }
    }
    else if(k == n){
        cout << 1 << " ";
        for(long long i = 1; i < n - 2; ++i){
            cout << 2 << " ";
        }
        cout << x + 1 << " " << 2 * x + 1 << "\n";
    }
    else if(n * (n - 1) / 2 == k){
        long long help = 1;
        for(long long i = 0; i < n; ++i){
            cout << help << " ";
            help += x;
        }
        cout << "\n";
    }
    else{
        for(long long i = 0; i <= 1000; ++i){
            for(long long j = 1; j <= n - i; ++j){
                if(i * j == k){
                    for(long long l = 0; l < i; ++l){
                        cout << 1 << " ";
                    }
                    for(long long l = 0; l < j; ++l){
                        cout << x + 1 << " ";
                    }
                    for(long long l = i + j; l < n; ++l){
                        cout << x << " ";
                    }
                    cout << "\n";

                    return 0;
                }
            }
        }

        for(long long i = 3; i <= 1000; ++i){
            for(long long l = 0; l <= n - i; ++l){
                if(x == 2 && l != 0 && l != n - i){continue;}
                if(k - i * (i - 1) / 2 - l * (i - 1) >= 0 && (k - i * (i - 1) / 2 - l * (i - 1)) % (i - 2) < 2 && (k - i * (i - 1) / 2 - l * (i - 1)) / (i - 2) == n - i - l){
                    long long help = 1;
                    for(long long j = 0; j < i; ++j){
                        cout << help << " ";
                        used[help] = true;
                        help += x;
                    }
                    help -= x;
                    for(long long j = 0; j < l; ++j){
                        cout << help + 1 << " ";
                    }
                    for(long long j = i + l; j < n; ++j){
                        if((k - i * (i - 1) / 2 - l * (i - 1)) % (i - 2) == 1 && i == n - 1){break;}
                        cout << help - 1 << " ";
                    }
                    if((k - i * (i - 1) / 2 - l * (i - 1)) % (i - 2) == 1){cout << help - 2 << "\n";}

                    return 0;
                }
            }
        }

        cout << -1 << "\n";
    }

    return 0;
}